unit InputForm;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, TntForms, FixTntCombo, TntStdCtrls;

type
  TNumberInputForm = class(TTntForm)
    Label1: TTntLabel;
    OKBtn: TTntButton;
    CancelBtn: TTntButton;
    Edit1: TTntEdit;
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

function NumberInputForm(AOwnoer: TComponent; ACaption, ALabel: WideString; var Value: WideString; ANumber: Boolean): boolean;

implementation

{$R *.dfm}

function NumberInputForm(AOwnoer: TComponent; ACaption, ALabel: WideString; var Value: WideString; ANumber: Boolean): boolean;
var
  dlg: TNumberInputForm;
  h: HWND;
begin
  Result := false;
  dlg := TNumberInputForm.Create(AOwnoer);
  try
    dlg.Caption := ACaption;
    dlg.Label1.Caption := ALabel;
    dlg.Edit1.Text := Value;
    h := dlg.Edit1.Handle;
    if ANumber then SetWindowLongW(h, GWL_STYLE, GetWindowLongW(h, GWL_STYLE) or ES_NUMBER);
    if dlg.ShowModal <> mrOk then exit;
    Value := dlg.Edit1.Text;
    Result := true;
  finally
    dlg.Free;
  end;

end;

end.

