unit ChildPopupMenu;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls,
  NotePadView, Menus, TntControls, TntMenus;

type
  TNotePadMenu = class(TtntPopupMenu)
    FUndo: TtntMenuItem;
    FRedo: TtntMenuItem;
//    FRedo2: TtntMenuItem;
    FCut: TtntMenuItem;
    FCopy: TtntMenuItem;
    FPaste: TtntMenuItem;
    FDelete: TtntMenuItem;
    FSelAll: TtntMenuItem;
//    FGoLine: TtntMenuItem;
//    FDateTime: TtntMenuItem;
    FReconvert: TTntMenuItem;
//    FSearch: TTntMenuItem;
    FFindPrev: TTntMenuItem;
    FFindNext: TTntMenuItem;
//    FReplace: TTntMenuItem;
//    FClearHighlight: TTntMenuItem;
//    FAddMark: TTntMenuItem;
//    FJumpMark: TTntMenuItem;
//    FDelMark: TTntMenuItem;
    FGoogleJP: TTntMenuItem;
//    FGoogleAll: TTntMenuItem;
    FYahoo: TTntMenuItem;
//    FGrep: TTntMenuItem;
  private
    procedure SetMenu(Sender: TObject); 
    procedure CreateMenuItems; 
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  end;

var
  NotePadPopup: TNotePadMenu;

procedure UnitInitialize;

implementation

uses wNotePad, ClipBrd, DM;

{ TNotePadMenu }

constructor TNotePadMenu.Create(AOwner: TComponent);
begin
  inherited;
  CreateMenuItems;
  OnPopup := SetMenu;
end;

procedure TNotePadMenu.CreateMenuItems;
var
  AMenu: TtntMenuItem;
begin
  FUndo := TtntMenuItem.Create(Self);
  FUndo.Caption := 'ɖ߂(&U)';
//  FUndo.ShortCut := TextToShortCut('Ctrl+Z');
  Items.Add(FUndo);
  FRedo := TtntMenuItem.Create(Self);
  FRedo.Caption := '蒼(&R)';
//  FRedo.ShortCut := TextToShortCut('Ctrl+Y');
  Items.Add(FRedo);
//  FRedo2 := TtntMenuItem.Create(Self);
//  FRedo2.Visible := false;
//  FRedo2.ShortCut := TextToShortCut('Shift+Ctrl+Z');
//  Items.Add(FRedo2);
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FCut := TtntMenuItem.Create(Self);
  FCut.Caption := '؂(&T)';
//  FCut.ShortCut := TextToShortCut('Ctrl+X');
  Items.Add(FCut);
  FCopy := TtntMenuItem.Create(Self);
  FCopy.Caption := 'Rs[(&V)';
//  FCopy.ShortCut := TextToShortCut('Ctrl+C');
  Items.Add(FCopy);
  FPaste := TtntMenuItem.Create(Self);
  FPaste.Caption := '\t(&P)';
//  FPaste.ShortCut := TextToShortCut('Ctrl+V');
  Items.Add(FPaste);
  FDelete := TtntMenuItem.Create(Self);
  FDelete.Caption := '폜(&L)';
  Items.Add(FDelete);
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FSelAll := TtntMenuItem.Create(Self);
  FSelAll.Caption := 'ׂđI(&A)';
//  FSelAll.ShortCut := TextToShortCut('Ctrl+A');
  Items.Add(FSelAll);
{  FGoLine := TtntMenuItem.Create(Self);
  FGoLine.Caption := 'sֈړ(&G)...';
  Items.Add(FGoLine);
  FDateTime := TtntMenuItem.Create(Self);
  FDateTime.Caption := 'tƎ(&D)';
  Items.Add(FDateTime);
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);    }
//  AMenu := TtntMenuItem.Create(Self);
//  AMenu.Caption := '';
//  AMenu.Enabled := false;
//  Items.Add(AMenu);
//  AMenu := TtntMenuItem.Create(Self);
//  AMenu.Caption := '';
//  AMenu.Enabled := false;
//  Items.Add(AMenu);
//  FSearch := TtntMenuItem.Create(Self);
//  FSearch.Caption := '(&F)...';
//  FSearch.Break := mbBreak;
//  Items.Add(FSearch);
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FFindPrev := TtntMenuItem.Create(Self);
  FFindPrev.Caption := 'IɌ(&P)';
  Items.Add(FFindPrev);
  FFindNext := TtntMenuItem.Create(Self);
  FFindNext.Caption := 'IɌ(&N)';
  Items.Add(FFindNext);
//  AMenu := TtntMenuItem.Create(Self);
//  AMenu.Caption := '-';
//  Items.Add(AMenu);
//  FReplace := TtntMenuItem.Create(Self);
//  FReplace.Caption := 'u(&R)...';
//  Items.Add(FReplace);
//  AMenu := TtntMenuItem.Create(Self);
//  AMenu.Caption := '-';
//  Items.Add(AMenu);
//  FClearHighlight := TtntMenuItem.Create(Self);
//  FClearHighlight.Caption := 'nCCg(&H)';
//  Items.Add(FClearHighlight);
{  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FAddMark := TtntMenuItem.Create(Self);
  FAddMark.Caption := 'ݒu(&M)';
  Items.Add(FAddMark);
  FJumpMark := TtntMenuItem.Create(Self);
  FJumpMark.Caption := 'sֈړ(&J)...';
  Items.Add(FJumpMark);
  FDelMark := TtntMenuItem.Create(Self);
  FDelMark.Caption := '폜(&D)...';
  Items.Add(FDelMark);  }
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FGoogleJP := TtntMenuItem.Create(Self);
  FGoogleJP.Caption := 'Google {(&G)';
  Items.Add(FGoogleJP);
//  FGoogleAll := TtntMenuItem.Create(Self);
//  FGoogleAll.Caption := 'Google EFuS(&W)';
//  Items.Add(FGoogleAll);
  FYahoo := TtntMenuItem.Create(Self);
  FYahoo.Caption := 'Yahoo! (&Y)';
  Items.Add(FYahoo);
{  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FGrep := TTntMenuItem.Create(Self);
  FGrep.Caption := 'eLXgt@C(&I)...';
  Items.Add(FGrep); }
  AMenu := TtntMenuItem.Create(Self);
  AMenu.Caption := '-';
  Items.Add(AMenu);
  FReconvert := TTntMenuItem.Create(Self);
  FReconvert.Caption := 'ĕϊ(&E)';
  Items.Add(FReconvert);
end;

destructor TNotePadMenu.Destroy;
begin
  while Items.Count > 0 do Items[0].Free;
  inherited;
end;

procedure TNotePadMenu.SetMenu(Sender: TObject);
var
  Sel, HasText, {ABox,} SelNoCrlf: Boolean;
begin
  if FocusedNotePad <> nil then
  begin
    Sel := FocusedNotePad.SelectionLength <> 0;
    HasText := ClipBoard.HasFormat(CF_TEXT) or ClipBoard.HasFormat(CF_UNICODETEXT);
//    ABox := FocusedNotePad.BoxSelected;
    SelNoCrlf := FocusedNotePad.SelectedWithoutCRLF;
    FUndo.Enabled := FocusedNotePad.CanUndo;
    FRedo.Enabled := FocusedNotePad.CanRedo;
//    FRedo2.Enabled := FocusedNotePad.CanRedo;
    FCut.Enabled := Sel;
    FCopy.Enabled := Sel;
    FPaste.Enabled := HasText;
    FDelete.Enabled := Sel;
    FSelAll.Enabled := FocusedNotePad.TextLength > 0;
    FReconvert.Enabled := SelNoCrlf;//Sel and (not ABox);
    FFindPrev.Enabled := SelNoCrlf;
    FFindNext.Enabled := SelNoCrlf;
//    FClearHighlight.Enabled := FHighlightText <> '';
//    FJumpMark.Enabled := FocusedNotePad.MarkCount > 0;
//    FDelMark.Enabled := FocusedNotePad.MarkCount > 0;
    FGoogleJP.Enabled := SelNoCrlf;//Sel and (not ABox);
//    FGoogleAll.Enabled := Sel and (not ABox);
    FYahoo.Enabled := SelNoCrlf;//Sel and (not ABox);
  end;
end;

procedure UnitInitialize;
begin
  NotePadPopup := TNotePadMenu.Create(nil);
end;

initialization
finalization
  if Assigned(NotePadPopup) then NotePadPopup.Free;
end.
