unit InputDialog;

interface

uses Windows,Messages;


function NumberInputBox(hOwner: HWND;const Title, Text:widestring;
      var Default: Widestring;Number:boolean): integer;

implementation

{$R Numberinput.res}

var
    FInput,FTitle,FText:WideString;
    FNumber:boolean;

function NumberInputBox(hOwner: HWND;const Title, Text:widestring;
      var Default: Widestring;Number:boolean): integer;
  function DialogFunc(hDialog: HWnd; AMessage, WParam: UINT;
               LParam: LPARAM): Bool; stdcall;
  var hEdit:HWND;
  begin
    Result := False;
    case AMessage of
    WM_INITDIALOG: begin
      hEdit:=GetDlgItem(hDialog,800);
      if FNumber then
        SetWindowLongW(hEdit,GWL_STYLE,GetWindowLongW(hEdit,GWL_STYLE)or ES_NUMBER);
      SetDlgItemTextW(hDialog,799,PWChar(FText));
      SetDlgItemTextW(hDialog,800,PWChar(FInput));
      SetWindowTextW(hDialog, PWChar(FTitle));
      Result:=true;
      Exit;
    end;
      WM_COMMAND:
      case LOWORD(WParam) of
        IDCANCEL,802:
        begin
          EndDialog(hDialog, IDCANCEL);
          Result:=true;
          Exit;
        end;
        801:
        begin
          hEdit:=GetDlgItem(hDialog,800);
          SetLength(FInput,GetWindowTextLengthW(hEdit)+1);
          SetLength(FInput,GetWindowTextW(hEdit,PWChar(FInput),Length(FInput)));
          EndDialog(hDialog, IDOK);
          Result:=true;
          Exit;
        end;
      end;
    end;
  end;
begin
  FNumber:=Number;
  FInput:=Default;
  FTitle:=Title;
  FText:=Text;
  Result:=DialogBoxW(hInstance,'NUMBERINPUT',hOwner,@DialogFunc);
  Default:=FInput;
end;


end.
