unit codedlgunit;

interface

uses Windows,Messages,commdlg;

type
  TCodeOpenSave=class(TObject)
  private
    FCodePage:integer;
    FPathName:widestring;
    FDefExt:widestring;
    FInitialDir:WideString;
    FMyDoc:WideString;
    FFilter:widestring;
    FFilterIndex:Integer;
    FCaption:widestring;
    FWindow:HWND;
    FUseCode:boolean;
    procedure InitStruct(var struct:TOpenFilenameW);
    function GetPathname:widestring;
    procedure SetPathName(value: widestring);
    function GetDefExt: WideString;
    procedure SetDefExt(const Value: WideString);
    function GetInitialDir: WideString;
    procedure SetInitialDir(const Value: WideString);
  public
    constructor Create;
    function OpenExcute(hWindow:HWND):boolean;
    function SaveExcute(hWindow:HWND):boolean;
    property CodePage:integer read FCodePage;
    //ʏ̃tpXOK
    property PathName:widestring read GetPathname write SetPathName;
    //nilg`ɕϊ邱ƁB
    property Filter:widestring read FFilter write FFilter;
    //1x[X
    property FilterIndex:Integer read FFilterIndex write FFilterIndex;
    //ʏ̃LvV
    property Caption:widestring read FCaption write FCaption;
    property UseCode:boolean read FUseCode write FUseCode;
    property DefExt: WideString read GetDefExt write SetDefExt;
    property InitialDir: WideString read GetInitialDir write SetInitialDir;
  end;

implementation

uses ShlObj, ActiveX, wsfileop;

{$R CodeDlg.res}

var
  ofnComboResult:integer;

const
//(fcNONE,fcANSI,fcUNICODE,fcBIGEND,fcUTF8W,fcUTF7,fcUTF8U,fcEUC,fcJIS,fcASCII,fc1251,fcBIN);

  OFN_CODE00:widestring='I';
  OFN_CODE01:widestring='VtgJIS';
  OFN_CODE02:widestring='Unicode';
  OFN_CODE03:widestring='Unicode(Big Endian)';
  OFN_CODE04:widestring='UTF-8(BOM)';
  OFN_CODE05:widestring='UTF-7';
  OFN_CODE06:widestring='UTF-8';
  OFN_CODE07:widestring='EUC';
  OFN_CODE08:widestring='JIS(ISO-2022-JP)';
  OFN_CODE09:widestring='ASCII';
  OFN_CODE10:widestring='L(1251)';
  OFN_CODE11:widestring='ɑ̎(950)';
  OFN_CODE12:widestring='ȑ̎(936)';
  OFN_CODE13:widestring='؍(949)';


function SaveDialogExecute(OpenSave:TOpenFileNameW):integer;
var
  PreResult:boolean;
  function DialogFunc(hDialog: HWnd; AMessage, WParam: UINT;
               LParam: LPARAM): Bool; stdcall;
  var hCombo:HWND;
  begin
    Result := False;
    case AMessage of
      WM_INITDIALOG: begin
        hCombo:=GetDlgItem(hDialog,9703);
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE00)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE01)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE02)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE03)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE04)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE05)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE06)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE07)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE08)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE09)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE10)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE11)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE12)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE13)));
        SendMessageW(hCombo,CB_SETCURSEL,0,0);
        ofnComboResult:=0;
        Result:=true;
        Exit;
      end;
      WM_COMMAND:begin
        hCombo:=GetDlgItem(hDialog,9703);
        ofnComboResult:=SendMessageW(hCombo,CB_GETCURSEL,0,0);
        Result:=true;
        Exit;
      end;
    end;
  end;
begin
  OpenSave.lpfnHook:=@DialogFunc;
  OpenSave.Flags :=OFN_OVERWRITEPROMPT  or OFN_HIDEREADONLY  or OFN_EXPLORER or OFN_NOCHANGEDIR;
  if OpenSave.lpTemplateName<>nil then OpenSave.Flags:=OpenSave.Flags or OFN_ENABLETEMPLATE or OFN_ENABLEHOOK;
  PreResult:=GetSaveFileNameW(OpenSave);
  if PreResult then Result:=ofnComboResult else Result:=-1;
end;

function OpenDialogExecute(OpenSave:TOpenFileNameW):integer;
var
  PreResult:boolean;
  function DialogFunc(hDialog: HWnd; AMessage, WParam: UINT;
               LParam: LPARAM): Bool; stdcall;
  var
    hCombo:HWND;
  begin
    Result := False;
    case AMessage of
      WM_INITDIALOG: begin
        hCombo:=GetDlgItem(hDialog,9703);
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE00)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE01)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE02)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE03)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE04)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE05)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE06)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE07)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE08)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE09)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE10)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE11)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE12)));
        SendMessageW(hCombo,CB_INSERTSTRING,-1,integer(pwchar(OFN_CODE13)));
        SendMessageW(hCombo,CB_SETCURSEL,0,0);
        ofnComboResult:=0;
        Result:=true;
        Exit;
      end;
      WM_COMMAND:begin
        hCombo:=GetDlgItem(hDialog,9703);
        ofnComboResult:=SendMessageW(hCombo,CB_GETCURSEL,0,0);
        Result:=true;
        Exit;
      end;
    end;
  end;
begin
  OpenSave.lpfnHook:=@DialogFunc;
  OpenSave.Flags := OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_EXPLORER or OFN_NOCHANGEDIR;
  if OpenSave.lpTemplateName<>nil then OpenSave.Flags:=OpenSave.Flags or OFN_ENABLETEMPLATE or OFN_ENABLEHOOK;
  PreResult:=GetOpenFileNameW(OpenSave);
  if PreResult then Result:=ofnComboResult else Result:=-1;
end;

function GetMyDoc: WideString;
//http://homepage1.nifty.com/MADIA/delphi/Win32API/ShFolder.htm
var
  Root : PItemIDList;
  Buffer : PWChar;
  Memory : IMalloc;
begin
  SHGetMalloc(Memory);
  Buffer := Memory.Alloc(MAX_PATH * 2);
  //tH_̈ʒu擾
  SHGetSpecialFolderLocation(0, CSIDL_PERSONAL, Root);
  //ItemIDList\̂pXo
  SHGetPathFromIDListW(Root, Buffer);
  Result := Buffer;
  //̉
  Memory.Free(Root);
  Memory.Free(Buffer);
end;
{ TCodeOpenSave }

constructor TCodeOpenSave.Create;
begin
  inherited Create;
  FWindow:=0;
  FPathName:=#0;
  SetLength(FPathName,MAX_PATH);
  FFilter:=#0;
  FFilterIndex:=1;
  FCaption:='';
  FUseCode:=true;
  FDefExt := #0;
  FInitialDir := #0;
end;

function TCodeOpenSave.GetDefExt: WideString;
begin
  Result:=widestring(pwchar(FDefExt));
end;

function TCodeOpenSave.GetInitialDir: WideString;
begin
  Result:=widestring(pwchar(FInitialDir));
end;

function TCodeOpenSave.GetPathname: widestring;
begin
  Result:=widestring(pwchar(FPathName));
end;

procedure TCodeOpenSave.InitStruct(var struct: TOpenFilenameW);
begin
  FillChar(struct,SizeOf(struct),0);
  struct.lStructSize:=SizeOf(struct);
  struct.hWndOwner:=FWindow;
  struct.hInstance:=HInstance;

//  struct.lpstrFilter:= 'eLXg(*.txt)'#0'*.txt'#0'ׂẴt@C'#0'*.*'#0#0;
  struct.lpstrFilter:=pwchar(FFilter);
  struct.nFilterIndex:=FFilterIndex;
  if Length(FCaption)>0 then struct.lpstrTitle:=pwchar(FCaption) else struct.lpstrTitle:=nil;
  struct.nMaxFile:=MAX_PATH;
  struct.lpstrDefExt:=pwchar(FDefExt);
//  if FShowPlaceBar then
    struct.lpTemplateName:=MAKEINTRESOURCEW(9701);
//  else begin
//    struct.lpTemplateName:=MAKEINTRESOURCEA(9700);
//    struct.FlagsEx:=OFN_EX_NOPLACESBAR;
//  end;// 'FILEDLGEX';
  if not FUseCode then struct.lpTemplateName:=nil;
  struct.lpstrFile:=pwchar(FPathName);
  if FInitialDir[1] = #0 then begin
    FMyDoc := GetMyDoc;
    struct.lpstrInitialDir := PWChar(FMyDoc);
  end else struct.lpstrInitialDir := PWChar(FInitialDir);
end;

function TCodeOpenSave.OpenExcute(hWindow:HWND): boolean;
var
  struct:TOpenFilenameW;
//  PrevDir:widestring;
begin
  FWindow := hWindow;
//  PrevDir := GetCurrentDirW;
  try
    FCodePage:=-1;
    InitStruct(struct);
    Result:=(OpenDialogExecute(struct)>-1);
    if Result then begin
      FFilterIndex:=struct.nFilterIndex;
      FCodePage:=ofnComboResult;
    end;
  finally
//    SetCurrentDirW(PrevDir);
  end;
end;

function TCodeOpenSave.SaveExcute(hWindow:HWND): boolean;
var
  struct:TOpenFilenameW;
//  PrevDir:widestring;
begin
  FWindow := hWindow;
//  PrevDir := GetCurrentDirW;
  try
    FCodePage:=-1;
    InitStruct(struct);
    Result:=(SaveDialogExecute(struct)>-1);
    if Result then begin
      FFilterIndex:=struct.nFilterIndex;
      FCodePage:=ofnComboResult;
    end;
  finally
//    SetCurrentDirW(PrevDir);
  end;
end;

procedure TCodeOpenSave.SetDefExt(const Value: WideString);
begin
  FDefExt:=value+#0;
  SetLength(FDefExt,MAX_PATH);
end;

procedure TCodeOpenSave.SetInitialDir(const Value: WideString);
begin
  FInitialDir:=value+#0;
  SetLength(FInitialDir,MAX_PATH);
end;

procedure TCodeOpenSave.SetPathName(value: widestring);
begin
  FPathName:=value+#0;
  SetLength(FPathName,MAX_PATH);
end;

end.
