unit splitter2;

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
 Dialogs,ExtCtrls;

type
  TFixedSplitter = class(TSplitter)
  private
  { Private 錾 }
  protected
  { Protected 錾 }
    APshowHintF: boolean;
    procedure Paint; override;
  public
    procedure MouseDown(Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer); override;
  { Public 錾 }
  published
  { Published 錾 }
  end;


implementation

procedure TFixedSplitter.MouseDown(Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  ApshowhintF := Application.ShowHint;
  Application.ShowHint := False;
end;

procedure TFixedSplitter.MouseUp(Button: TMouseButton;
                                   Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  Application.ShowHint := ApShowhintF;
end;

procedure TFixedSplitter.Paint;
var
  R: TRect;
begin
  inherited;
  R := ClientRect;
  with Canvas do begin
    Brush.Color := Color;
    FillRect(R);
    InflateRect(R,1,-2);
    Pen.Color := clGrayText;
    Rectangle(R);
  end;

end;

end.

